<?

/**
 *                                               
 *
 *                                                                          
 **/
function compare_version($version, $compare, $sep = ".") {
$version = explode($sep, $version);
$compare = explode($sep, $compare);
foreach ($version as $key=>$subversion) {
if ($subversion < $compare[$key]) return false;
if ($subversion > $compare[$key]) return true;
}
return true;
}

/**
 *                                                                                                                   
 * 
 *           //        /    /  /                           #                                            
 
 *                                                                                                                    /    
 *                                                                               
 *                         
 *                                                       
 *                                     
 *                                                    
 *       
 *               //                     
 *               //                     
 *               //            
 *                             //              /           
 *              //                                         
 *   
 */
function parse_version($string) {
preg_match("/(\d)\.(\d{1,2})\.(\d{1,2})-?([a-zA-Z]\w*)?-?((\d+\.?\d+)-(\d+))?/", $string, $m);
return array(
'major' => $m[1],
'minor' => $m[2],
'patch' => $m[3],
'build' => $m[6],
'count' => $m[7]
);
}


/**
 *                                                                   
 */
function prettyprint_gcnversion($v) {
if (!$v['major']) {
return i18n('Unknown');
}

$ver = $v['major'] . '.' . $v['minor'] . '.' . $v['patch'];
if ($v['build']) {
$ver .= ', Build ' . $v['build'] . '-' . $v['count'];
}
return $ver;
}

/**
 *                                                      
 */
function get_current_gcnversion() {
$r = query("SELECT textvalue FROM nodesetup WHERE name = 'version'");
return parse_version($r['arr'][0]['textvalue']);
}


/**
 *                                                                                      
 */
function get_license_key($charcount = NULL) {
global $FAKE_LICENSE_KEY, $NODEETCPATH;
if ($FAKE_LICENSE_KEY) {
return $FAKE_LICENSE_KEY;
}
$_l = file("$NODEETCPATH/tomcat/gentics/license.key");
$_l = trim($_l[0]);
if($charcount !== NULL) {
$_l = substr($_l,0,$charcount);
}
return $_l;
}


/**
 *                          
 */
function get_hardware_checksum() {
global $NODEETCPATH;
$hw = file("$NODEETCPATH/tomcat/gentics/license.key");
return trim($hw[1]);
}



?>