<?

/**
*                                                                       
*/

class xml_parser extends BaseObject {

var $parser;

var $error;
var $errorLine;
var $errorCol;

var $way;
var $toLower;
var $toUpper;

var $struct;
var $debugLevel;

var $splitCDATA;

var $xml;

//                                      
 function xml_parser($way = "ASSOC") {

$this->parser = xml_parser_create();

xml_set_object($this->parser, &$this);

$this->splitCDATA = false;

$this->setDebugLevel(0);

$this->setXML("");
$this->setWay($way);
$this->setLower(false);
$this->setUpper(true);
}

function parse($xml = "") {

if ($xml) $this->setXML($xml);

$this->struct = array();
$this->error = "";
$this->errorLine = 0;
$this->errorCol = 0;

$values = array();
$index = array();

$error = xml_parse_into_struct($this->parser, $this->xml, $values, $index);

if (!$error) {
$this->error = xml_get_error_code($this->parser);
$this->errorLine = xml_get_current_line_number($this->parser);
$this->errorCol = xml_get_current_column_number($this->parser);
} else {
$pos = 0;
$this->struct = $this->getChilds($values, $pos, 1);
}

return $error?0:1;
}

//                 /                  
 function setXML($value) {
$this->xml = $value;
}

//                                                          
 function setWay($value) {

$way = strtoupper($value);

if (!$way) $way = "BOTH";

if ($way == "ASSOC" || $way == "NUM" || $way == "BOTH") 
$this->way = $way;
}

//                                
 function setLower($value) {
$this->toLower = $value?true:false;
$this->toUpper = ($value)?false:$this->toUpper;
}

function setUpper($value) {
$this->toUpper = $value?true:false;
$this->toLower = ($value)?false:$this->toLower;
}

function setDebugLevel($value) {
$this->debugLevel = $value;
}

function getXML() {
return $this->xml;
}

function getWay() {
return $this->way;
}

function getLower() {
return $this->toLower;
}

function getUpper() {
return $this->toUpper;
}

function getError() {
return $this->error;
}

function getErrorMessage() {
return xml_error_string($this->error);
}

function getErrorLine() {
return $this->errorLine;
}

function getErrorCol() {
return $this->errorCol;
}

function getDebugLevel() {
return $this->debugLevel;
}

function getStruct() {
return $this->struct;
}

function getChilds( $values, &$pos )
{
$ret = array();
$lastLevel = -1;
while ( $pos < count($values) )
{
if ( $values[$pos] !== NULL )
{
$tag = $values[$pos];
//                                            /   
 //                                           /   
 if ( $tag["level"] > $lastLevel && $lastLevel >= 0 )
{
//                                             /   
 $rTag = $this->getChilds( $values, $pos );

$ret[$lastTag]["childs"][key($rTag)][] = $rTag[key($rTag)];
continue;
}
else if ( $tag["level"] < $lastLevel )
{
return $ret;
}

switch ( $tag["type"] )
{
case "open":
case "complete":
if ( isset($tag["value"]) )
$ret[$tag["tag"]]["value"] = $tag["value"];
if ( isset($tag["attributes"] ) )
$ret[$tag["tag"]]["attributes"] = $tag["attributes"];
break;		
case "cdata":
if ( $ret[$tag["tag"]]["value"] )
$ret[$tag["tag"]]["value"] .= $tag["value"];
else
$ret[$tag["tag"]]["value"] = $tag["value"];
break;	
}
$lastLevel = $tag["level"];
$lastTag = $tag["tag"];
}
$pos++;
}
return $ret;
}

//                                                                       
 function _old_getChilds($values, &$pos, $level, $childs = "") {


if (!is_array($childs)) $childs = array();

$debug = ($this->debugLevel > 1);

if ($debug) echo "-- getit($level, $pos) -- <br>\n";

$key = $this->getLastChild($childs);
while ($pos < count($values)) {

$tag = $values[$pos];

if ($debug) echo "tag(".$tag["tag"].") l(".$tag["level"].") type(".$tag["type"].") p($pos) <br>\n";	

//                                                                                      
 if ($tag["level"] < $level) {
if ($debug) echo "jumpdown ($level -> ".$tag["level"].") <br>\n";
$pos--;
return $childs;
}

//                                                     
 if ($tag["level"] > $level) {
if ($debug) echo "jumpup ($level -> ".$tag["level"].")<br>\n";
static $counti=0;
$counti++;
$el = $this->getChild($childs, $key);
$el["childs"] = $this->getChilds($values, $pos, $level + 1, $el["childs"]);
$childs = $this->setChild($childs, $key, $el);
if ($debug) echo "ret up ($level, $pos) <br>\n";	
//               
 $pos++;
continue;
}

$new_childs = "";

switch ($tag["type"]) {
case "cdata": 
$el = $this->getChild($childs, $key);
if ($this->splitCDATA) {
$el["cdata"] .= $tag["value"];
} else {
$el["value"] .= $tag["value"];
}
$this->setChild($childs, $key, $el);
break;
case "open":
$pos++;
$new_childs = $this->getChilds($values, $pos, $level + 1);
if ($debug) echo "ret open ($pos, ".$tag["tag"].") <br>\n";
case "complete":
$el = array();
$el["name"] = ($this->toLower)?strtolower($tag["tag"]):$tag["tag"];
$el["type"] = $tag["type"];
if (is_array($new_childs)) $el["childs"] = $new_childs;
if ($tag["value"]) $el["value"] = $tag["value"];

if (is_array($attr = $tag["attributes"])) {
if ($this->toLower) {
$el["attributes"] = array();
reset($attr);
while (list($key,$val) = each($attr)) {
$el["attributes"][strtolower($key)] = $val;
}
} else {
$el["attributes"] = $attr;
}
}

$key = $this->addChild($childs, $el);
$childs = $this->setChild($childs, $key, $el);

break;
case "close":
return $childs;
break;
}

$pos ++;
}

return $childs;

}

function setChild($struct, $key, $val) {
if ($this->way == "ASSOC" || $this->way == "BOTH") {
$struct[$key[0]][$key[1]] = $val;
}
if ($this->way == "NUM" || $this->way == "BOTH") {
$struct[(is_array($key)?$key[2]:$key)] = $val;
}
return $struct;
}

function getChild($struct, $key) {
if (is_array($key)) {
$el = $struct[$key[0]][$key[1]];
} else {
$el = $struct[$key];
}
return $el;
}

function addChild($struct, $val) {
$both = "/";
switch ($this->way) {
case "BOTH":
$both = is_array($struct)?(int) (count($struct)/2) : 0;
case "ASSOC":
$key = array($val["name"], is_array($struct[$val["name"]])?count($struct[$val["name"]]):0, $both);
break;
case "NUM":
$key = is_array($struct)?count($struct):0;
break;
}
return $key;
}

function getLastChild($struct) {
if (!is_array($struct) || count($struct) < 1) return -1;

if ($this->way == "NUM") {
$key = count($struct) - 1;
}
if ($this->way == "BOTH") {
$num = (int) (count($struct) / 2) - 1;
$key = array($struct[$num]["name"],count($struct[$struct[$num]["name"]]) - 1, $num);
}
if ($this->way == "ASSOC") {
end($struct);
list($k,$v) = each($struct);
$key = array($k,count($struct[$k]) - 1);
}

return $key;
}

}

?>
