<?
class XNLParser extends NodeParser {

var $d_requestor;

/**
  *                          
  **/
function XNLParser() {
parent::NodeParser(LINKT_XNL);
$this->setParseTagParams(true);
$this->setParseTagResult(false);
$this->initDefaultRequestor();
$this->initDefaultParser();
}

function getParserKey() {
return "xnl";
}

function initDefaultRequestor() {
global $XNL_FUNCTION, $DEBUG;
$xnlloader = new XNLLoader($XNL_FUNCTION);
$xnlloader->fetchPackages();
$requestor = new XNLRequest($xnlloader);
$this->d_requestor = $requestor;
}

function initDefaultParser() {
//                                 
 //    
 $parser = new XNLIfParser();
$this->addObjectParser("if",$parser);
//                                                                *    *
 unset( $parser );

//      
 $parser = new XNLFunctionParser($this->d_requestor);
$this->addObjectParser("func", $parser, array("function"));
unset( $parser );

//      
 $parser = new XNLPropertyParser();
$this->addObjectParser("prop", $parser, array("property"));
}

function &getRequestor() {
return $this->d_requestor;
}

function updateCache() {
node_class("nodecache");
$loader =& $this->d_requestor->getLoader();
$packs = $loader->getPackages();
foreach ($packs as $package=>$pack) {
$funcs = $loader->getFunctions($package);
foreach ($funcs as $function=>$func) {
$full = $package.".".$function;
if (!$this->d_requestor->funcAllowCache($full)) continue;
$int = $this->d_requestor->getFuncCacheInterval($full);
//                                            
 if (!$int) continue;
NodeCache::refreshObjects($this->getParserKey(), "func", $full, $int);
///                                                                                
 NodeCache::refreshObjects($this->getParserKey(), "func", $function, $int);
}
}
}

function _generateTags($properties, &$isend, &$hasparts, $tagcode) {
$tags = array();

//                                                         
 $ctags = array("end","else");

//                         
 $stags = array("else");

$taglist = array();
reset($properties);
$props = array();
if ( isset( $properties["evalalways"] ) )
$props["evalalways"] = $properties["evalalways"];
while (list($key,$prop) = each($properties)) {
//                  
 if (in_array($key, $stags) || $key == "end") {
$tag = new ParserSplitter($key);
unset($properties[$key]);
$taglist[] = $tag;
}
//                          
 if ($key == "type") {
$type = $prop;
$name = $properties["name"];
unset($properties["type"]);
unset($properties["name"]);
$tag = new ParserTag($type);
$tag->setKeyname($name);
$tag->setProperties($properties);
$taglist[] = $tag;
break;
}
//                   /               
 if ($key == "func" || $key == "function") {
$type = "function";
$name = $properties[$key];
$edit = $properties["edit"];
unset($properties[$key]);
unset($properties["edit"]);
$tag = new ParserTag($type);
$tag->setKeyname($name);
$props["edit"] = $edit;
$tag->setProperties($props);
$taglist[] = $tag;
}
if ($key == "prop" || $key == "property") {

$type = "property";
$name = $properties[$key];
unset($properties[$key]);
$tag = new ParserTag($type);
$tag->setKeyname($name);
$props["object"] = $properties["object"];
$tag->setProperties($props);
$taglist[] = $tag;
}
if ($key == "if") {
$type = "if";
$if = $properties["if"];
$cond = ($properties["cond"])?$properties["cond"]:$properties["condition"];
$cond = ($cond)?$cond:$if;
unset($properties["if"]);
unset($properties["cond"]);
unset($properties["condition"]);
if (!$cond) {
//                              
 
}
$tag = new ParserTag($type);
$props["cond"] = $cond;
$tag->setProperties($props);
$taglist[] = $tag;
}
}

//                                                     
 $key = 0;
$keylist = array();
$ltags =& $tags;
reset($taglist);
while (list($k, $tag) = each($taglist)) {
$name = $tag->getTagType();
$closed = in_array($name, $ctags);
if (is_a($tag, "parsertag")) {
$keylist[] = $key;
$ltags[$key] = $tag;
$ltags =& $tag->getParts();
$key = 0;
} else if ($name == "end") {
$isend = true;
$closed = true;
break;
} else {
$key++;
$ltags[$key] = $tag;
}
}

if (count($taglist) > 1) $isend = true;

$hasparts = ($closed || !$hasparts)?false:$keylist;

if (count($tags) == 0 && !$isend) {
$tags[] = new NodeException(i18n("Could not build up XNL tag '{0}'.",0,$tagcode));
$hasparts = false;
}
return $tags;
}

function _getTagPrefixList() {
$tags = array("<xnl>"=>array("isend"=>false, "taglen"=>4),
"<xnl "=>array("isend"=>false, "taglen"=>5),
"</xnl>"=>array("isend"=>true, "taglen"=>5),
"</xnl "=>array("isend"=>true, "taglen"=>6));
return $tags;
}

}

?>
