<?php

GUIFactory::setMainGUI("main");

$maingui = &GUIFactory::getMainGUI();
$maingui->includeJS( "hiselector" );
$maingui->includeJS( "jquery" );

node_class("htmlformwizard");

//              
//                                   /                                         
//           

class InstallTypeFormatter {
function format(&$row) {
global $T_TYPE;

return $T_TYPE[$row['ttype']]['name'];
}
}

class InstallIconFormatter {
function format(&$row) {
global $T_TYPE;

return img( $T_TYPE[$row['ttype']]['folderclosed'] );
}
}

class InstallAssFormatter {
function format(&$row) {
return i18n('Global ID').": ".$row["globalid"];
}
}

class InstallBuilder extends WizardBuilder  {

function prepareStep(&$wizard, $stepNr, &$form) {
if( $stepNr == 2 ) {
//                      
 $step1 = &$wizard->getStep(1);
$chooser = &$step1->resolveComponent( 'chooser' );
$dlurllist = $chooser->getComponent( 'dlurlList' );
$downloadurlComp = $dlurllist->getComponent( 'downloadurl' );
$downloadurl = $downloadurlComp->getText();

if( $downloadurl ) {
$chooser = &$step1->resolveComponent( 'chooser' );
$dlurlList = $chooser->getComponent( 'dlurlList' );
$urlpasswordComp = $dlurlList->getComponent( 'urlpassword' );
//                                                        
 $downloadurl = trim($downloadurl);
$downloadurl .= '&pw='.$urlpasswordComp->getText();
//                                     
 $oldurl = $downloadurlComp->getFieldValue('oldurl');
if( $oldurl != $downloadurl ) {
//                                    
 $contents = file_get_contents( $downloadurl );
if( !$contents ) {
$downloadurlComp->addError( new EMessage( i18n( "Unable to download exportfile from URL." ) ) );
$wizard->m_stepId = 1;
return;
}
$downloadurlComp->setFieldValue('oldurl', $downloadurl);
node_class( 'bundle' );
$bundle = Bundle::parseXML($contents, false);

if( $bundle === null ) {
$downloadurlComp->addError( new EMessage( i18n( "Unable to download exportfile from URL." ) ) );
$wizard->m_stepId = 1;
return;
}
//                                                  
 $cmpbundle = &Bundle::getImportBundleByGlobalId( $bundle->getFieldValue('globalprefix'), $bundle->getFieldValue('globalid') );
if( $cmpbundle !== NULL ) {
$downloadurlComp->addError( new EMessage( i18n( 'The given Import is already installed.' ) ) );
$wizard->m_stepId = 1;
return;
//                                                              
 //                                       
 // 
 }
$bundle->setFieldValue('updateurl', $downloadurl);
//                   
 $builds = &$bundle->_builds;
$buildinfos = array();
foreach( $builds as $build ) {
if( $build->getFieldValue('downloadurl') ) {
//                                               
 /*
                                                                                
                                             
                                                       
       
                                 
      */
$buildinfos[] = &$build;
unset( $build );
}
}

$bundle->_builds = &$buildinfos;
$downloadurlComp->setFieldValue('bundle', $bundle);
$downloadurlComp->setFieldValue('fromzipfile', false);
if( count($buildinfos) == 0 ) {
$JS .= "alert('". i18n('Bundle does not contain any builds.') . "');";
$wizard->m_stepId = 1;
} else if( count($buildinfos) == 1 ) {
//                                                         
 $downloadurlComp->setFieldValue('showstep2', false);
$wizard->m_stepId = 3;
} else {
$downloadurlComp->setFieldValue('showstep2', true);
//                         
 //                       
 //                                                           
 }
}
} else {
//                        
 $chooser = &$step1->resolveComponent('chooser' );
$fileupload = $chooser->getComponent( 'fileupload' );
$file = &$fileupload->getResultObject();
$dummyfile = new FileObject(null);
$fileupload->setFileObject( $dummyfile );
//                          
 if(!$file->getFilename()) {
$fileupload->addError( new EMessage( i18n( 'Please upload a file, or enter a valid download url.' ) ) );
$wizard->m_stepId = 1;
return;
}
$bundle = &BundleBuild::parseBundleMetaInfoFromZipFile($file->getFilename());
if ($bundle == null) {
$fileupload->addError(new EMessage(i18n('import_bundle_broken')));
$wizard->m_stepId = 1;
return;
}
$mybuild = &$bundle->_builds[0];
$date = $mybuild->getFieldValue('date');

$newfilename = BundleBuild::getBundleFileNameForDate( $date );
//                                                                                                             
 rename( $file->getFilename(), BundleBuild::getBundlePath() . $newfilename );
$mybuild->setFieldValue('filename', $newfilename);

$downloadurlComp->setFieldValue('bundle', $bundle);
$downloadurlComp->setFieldValue('newbundle', $bundle);


//                                                      
 $cmpbundle = &Bundle::getImportBundleByGlobalId( $bundle->getFieldValue('globalprefix'), $bundle->getFieldValue('globalid') );
$downloadurlComp->setFieldValue('isupdate', false);
if( $cmpbundle !== NULL ) {
//                                                  

$downloadurlComp->setFieldValue('isupdate', true);
//                                            
 $cmpbuild = $cmpbundle->getBuildByDate( $date );
if( $cmpbuild !== NULL ) {
$fileupload->addError( new EMessage( i18n( 'uploaded_build_exists' ) ) );
$wizard->m_stepId = 1;
return;
}

//                                          
 $downloadurlComp->setFieldValue('newbundle_id', $cmpbundle->getID());

//                                                        
 //                                                                            
 $wizard->m_stepId = 7;
$wizard->setButtonVisibility('back', false);
return;
}

//               
 //                   
 //                                                                    
 $downloadurlComp->setFieldValue('showstep2', false);
$downloadurlComp->setFieldValue('fromzipfile', true);
$wizard->m_stepId = 3;
}
} else if ( $stepNr == 3 ) {
}
}

function fillStep(&$wizard, $stepNr, &$form) {
global $T_TYPE;

if( $stepNr == 2 ) {
$step1 = &$wizard->getStep(1);
$chooser = $step1->resolveComponent('chooser' );
$dlurllist = $chooser->getComponent( 'dlurlList' );
$downloadurlComp = $dlurllist->getComponent( 'downloadurl' );
//                                                              
 $bundle = &$downloadurlComp->getfieldValue('bundle');
$buildinfos = &$bundle->_builds;
//                       

$versions = &$form->resolveComponent('versions');
$versions->setOptions( array() );
foreach( $buildinfos as $buildinfo ) {
//                                       
 if( $buildinfo->getFieldValue('downloadurl') ) {
//                                                                                                        
 //                                                                      /   
 $versions->setOption( $buildinfo->getFieldValue('date'), db2date($buildinfo->getFieldValue('date')) . ': ' . $buildinfo->getFieldValue('changelog'));
}
}
} else if( $stepNr == 3 ) {
$step1 = &$wizard->getStep(1);
$chooser = $step1->resolveComponent( 'chooser' );
$dlurllist = $chooser->getComponent( 'dlurlList' );
$downloadurlComp = $dlurllist->getComponent( 'downloadurl' );
$bundle =& $downloadurlComp->getFieldValue('bundle');
if( count( $bundle->_builds ) != 1 ) {
$step2 = &$wizard->getStep(2);
$selectversionComp = &$step2->resolveComponent( 'selectversion' );
$versionsComp = &$step2->resolveComponent('versions');

$selectversion = $selectversionComp->getSingleSelection();
$version = $versionsComp->getSingleSelection();
} else {
$selectversion = 'newest';
}




//                                     /                    /   
 $buildinfo = null;
if( $selectversion == 'newest' ) {
//                              
 $buildinfo = &$bundle->_builds[0];
//                      
 } else {
foreach( $bundle->_builds as $b ) {
if( $b->getFieldValue('date') == $version ) {
$buildinfo = &$b;
break;
}
}
}
//                   
 if( $buildinfo === null ) {
halt(7, 'Unable to find buildinfo.' );
}

$testbuild = $downloadurlComp->getFieldValue('build');
$newbundle = $bundle;
if( !$fromzipfile = $downloadurlComp->getFieldValue('fromzipfile') ) {
//                                                                     
 $newbundle = $buildinfo->downloadFile(true);
if( $newbundle === null ) {
halt(7, 'Unable to download bundle build from url:'. $buildinfo->getFieldValue('downloadurl'));
}
}

$newbundle->setFieldValue('updateurl', $bundle->getFieldValue('updateurl'));

$downloadurlComp->setFieldValue('build', $buildinfo);
$downloadurlComp->setFieldValue('newbundle', $newbundle);

$bundleComp = &$form->resolveComponent( 'versiondetails.bundle' );
$bundleComp->setText( $newbundle->getFieldValue( 'name' ) );

$descriptionComp = &$form->resolveComponent( 'versiondetails.description' );
$descriptionComp->setText( $newbundle->getFieldValue( 'description' ) );

$sourceComp = &$form->resolveComponent( 'versiondetails.source' );
$sourceComp->setText( $newbundle->getFieldValue('source') );

$versiondateComp = &$form->resolveComponent( 'versiondetails.versioninfo.versiondate' );
$versiondateComp->setText( db2date( $buildinfo->getFieldValue('date') ) );

$versionchangelogComp = &$form->resolveComponent( 'versiondetails.versioninfo.versionchangelog' );
$versionchangelogComp->setText( $buildinfo->getFieldValue( 'changelog' ) );


$containedobjectsComp = &$form->resolveComponent( 'versiondetails.containedobjects' );

//                                          
 $containedobjects = '';
$tables = $newbundle->_tables;

foreach( $tables as $table ) {
$ttype = $table['ttype'];
if( !$ttype || $table['count'] == 0 ) continue;
$containedobjects .= $table['count'] . 'x ' . img( $T_TYPE[$ttype]['folderclosed'] ) . ' ' . $T_TYPE[$ttype]['name'] . "<br/>";
}
//                                                     
 $containedobjectsComp->setText( $containedobjects );

} else if( $stepNr == 4 ) {
$step1 = &$wizard->getStep(1);
$chooser = $step1->resolveComponent( 'chooser' );
$dlurllist = $chooser->getComponent( 'dlurlList' );
$downloadurlComp = $dlurllist->getComponent( 'downloadurl' );
$newbundle = &$downloadurlComp->getFieldValue('newbundle');
$build = &$downloadurlComp->getFieldValue('build');

$objsComp = &$form->resolveComponent('target');
$detailsComp = &$form->resolveComponent('detaillist');
$ds = &$detailsComp->getDatasource();

//                                          
 $selectShowComponent = &$form->resolveComponent("selectshowcontents");

$objs = '<b>'.i18n('This bundle will install:').'</b><ul>';
switch($selectShowComponent->getSingleSelection()) {
case "overview":
//                           
 $detailsComp->setHidden(true);
$tables = $newbundle->_tables;
foreach( $tables as $table ) {
$ttype = $table['ttype'];
if( !$ttype ||$table['count'] == 0 ) continue;
$objs .= '<li>'.$table['count'] . 'x ' . img( $T_TYPE[$ttype]['folderclosed'] ) . ' ' . $T_TYPE[$ttype]['name'] . "</li>";
}
$objs .= "</ul>";
break;
case "details":
$detailsComp->setHidden(false);
if (count($ds->getItems()) == 0) {
$ds_objs = array();
$build->parseObjectInfoFromZipFile($newbundle->_tables, $build->getBundleFilePath());

while (list($ttype, $objects) = each($build->_objects)) {
foreach($objects as $object) {
$ds_objs[] = $object;
}
}

$ds->setItems(&$ds_objs);
}
break;
}
$objsComp->setText($objs);
}
}

function updateStep(&$wizard, $stepNr, &$form) {
$this->fillStep($wizard, $stepNr, $form);
}

function createStep(&$wizard, $stepNr, &$form) {
if ($stepNr == 1) {
//                                                                  
 node_class("textcomponent");
node_class("treecomponent");
node_class("filecomponent");
node_class("labelcomponent");
node_class("componentchooser");	
node_class("minibrowserobjectselector");
node_class("checkboxcomponent");

$form->setHeader(i18n("Install Bundle"));
$chooser = new ComponentChooser(i18n("install_url_upload"));

//                          
 $dlurlList = new ListComponent();
$downloadUrl = new TextComponent(i18n("Download URL"), true, "", REG_TEXT, 20, true);
$dlurlList->setComponent("downloadurl", $downloadUrl);
$urlpassword = new TextComponent(i18n("Password"), true, "", REG_TEXT, 20, true);
$dlurlList->setComponent("urlpassword", $urlpassword);
$chooser->setComponent("dlurlList", $dlurlList);

//            
 $maxfilesize = min(gtxreturn_bytes(ini_get('post_max_size')), gtxreturn_bytes(ini_get('upload_max_filesize')));
$fileuploadcomp = new FileComponent(i18n("File Upload").' ('.i18n('Up to {0}', 0, humanfilesize($maxfilesize)).')', true, false, true);
$chooser->setComponent("fileupload", $fileuploadcomp);
$form->addComponent("chooser", $chooser);

//                
 $overrideGroup = new CheckBoxComponent(i18n("overridegroup"), false);
$overrideGroup->setOnChangeAction(new SimpleFormAction("switchGroupOverride"));
$form->addComponent("overridegroup", $overrideGroup);
node_class( "minibrowserhiselector" );
node_class( "minibrowsersimpletree" );
node_class( "groupobject" );
$wrapper = new MinibrowserSimpleTree( 1, T_GROUPADMIN );
$wrapper->setTType( T_GROUP, new GroupObject() );
$groupSelector = new MinibrowserHiSelector( $wrapper, i18n("Select group") );
$groupSelector->setHidden(true);
$form->addComponent("importgroup", $groupSelector);

} else if ($stepNr == 2) {
//                                                                             
 node_class("radiolistcomponent");
$form->setHeader(i18n("Select Version"));

$selectVersion = new RadioListComponent(i18n("Select Version"));
$selectVersion->setOption("newest", i18n("Use newest version"));
$selectVersion->setOption("other", i18n("Use previous version"));
$selectVersion->setOnClickAction(new SimpleFormAction("selectVersion"));
$selectVersion->setSelection("newest");
$form->addComponent("selectversion", $selectVersion);

$versions = buildVersionList();
$versions->setHidden(true);
$form->addComponent("versions", $versions);
} else if ($stepNr == 3) {
//                       
 node_class('textcomponent');
node_class('textareacomponent');
node_class('listcomponent');
node_class('labelcomponent');
node_class('groupcomponent');

$main = new ListComponent();


$bundle = new LabelComponent( i18n( 'Name' ), '<a href="$STAG&do=1011&edit_id=1">Some Bundle</a>', true );
$main->setComponent('bundle', $bundle);

$description = new TextAreaComponent( i18n( 'Description' ), false, 'This is some crazy cool description', REG_TEXT, TRUE );
$main->setComponent('description', $description);

$source = new LabelComponent( i18n( 'Source' ), 'Development' );
$main->setComponent('source', $source);

$versioninfolist = new ListComponent();

$versiondate = new LabelComponent( i18n( 'Version date' ), '' );
$versioninfolist->setComponent( 'versiondate', $versiondate );

$versionchangelog = new TextAreaComponent( i18n( 'Changelog' ), false, 'Some changelog to let you know what has changed since the last build', REG_TEXT, TRUE );
$versioninfolist->setComponent( 'versionchangelog', $versionchangelog );

//                                                 
 $main->setComponent('versioninfo', $versioninfolist);


$main->setComponent('containedobjects', new LabelComponent( i18n('Contained Objects'), '', true)); //                             
 

$form->addComponent("versiondetails", $main);
} else if( $stepNr == 4 ) {

//                                                                   
 node_class("radiolistcomponent");
$selectShowContents = new RadioListComponent(i18n("import_show_contents"));
$selectShowContents->setOption("overview", i18n("import_show_contents_overview"));
$selectShowContents->setOption("details", i18n("import_show_contents_details"));
$selectShowContents->setOnClickAction(new SimpleFormAction("selectIm"));
$selectShowContents->setSelection("overview");
$form->addComponent("selectshowcontents", $selectShowContents);

node_class("minibrowserhiselector");
node_class("pageselector");
node_class("itemlistcomponent");
node_class("arraydatasource");
$form->addComponent('target', new LabelComponent(null, '', true));

//                                                  
 $dsn = new ArrayDatasource(array(), array('icon' => '', 'name' => i18n('Name')));
$dsn->setSearchable( false );
$dsn->addFormatter('icon', new InstallIconFormatter());
$dsn->addFormatter('ttype', new InstallTypeFormatter());
$dsn->addAssFormatter(new InstallAssFormatter());

$iList = new ItemList3("detaillist", $dsn );
$iList->sortCol = 'ttype';
$iList->sortWay = 'ASC';
$iList->setGroupableColumns(array('ttype'));
$iList->setNextSortWay('ttype');
$iList->setMaxListItems(50);

$list = new ItemListComponent( NULL, $iList );
$list->setHidden(true);

$form->addComponent('detaillist', $list);

$wizard->lastStep();
} else if( $stepNr == 5 ) {
//                               
 $main = new ListComponent();
$conflictdescription = new LabelComponent(null, 'Konflikte entstehen dadurch, dass lokal ein Objekt ver&auml;ndert wurde, das auch durch den aktuellen import geupdated werden soll.<br/>Objekte werden durch eine eineindeutige Id gekennzeichnet die sie global identifiziert unabh&auml;ngig davon auf welchem Gentics Content.Node System sie erzeugt wurden.', true);

$main->setComponent('conflictdescription', $conflictdescription);

$conflictbehavior = new RadioListComponent('Verhalten bei Objekten<br/>mit Konflikten');//                                                   
 $conflictbehavior->setOption("update", 'Ignorieren (Lokale Version bleibt bestehen)');//                                                       
 $conflictbehavior->setOption("override", 'Ersetzen (Version aus Bundle ueberschreibt lokale Version)');//                 
 //                                                                         
 $conflictbehavior->setOption("alwayscopy", 'Neu Anlegen (Lokale Version bleibt bestehen, Version aus Bundle wird als neues Objekt angelegt.)');//                              
 $main->setComponent("conflictbehavior", $conflictbehavior);

$diffstr = "<table><tr><th>Type</th><th>Version in Bundle</th><th>Local Version</th></tr>";
$diffstr .= "<tr><td>Tagtype</td><td>Sometagtype</td><td>Sometagtype (Imported on 2008-01-07)</td></tr>";
$diffstr .= "<tr><td>Tagtype</td><td>[Basic] Text/HTML</td><td>[GTX] Text/HTML (Created at 2004-04-07)</td></tr>";
$diffstr .= "<tr><td>Seite</td><td>Funktion des XNL-Navigationsmodules (en)</td><td>Demo-CMS-Projekt / Home / Mehrsprachige Seiten / Funktion des XNL-Navigationsmodules (en) (Created before system migration on 2008-01-07)</td></tr>";
$diffstr .= "</table>";
$diff = new LabelComponent("List of conflicts", $diffstr, true);
$main->setComponent('diff', $diff);


$form->addComponent("versiondetails", $main);

} else if( $stepNr == 6 ) {
//                               
 $form->addComponent( 'lbl', new LabelComponent(null, '<b>Import Summary</b>', true) );
$form->addComponent( 'summary', new LabelComponent(null, '<ul><li>Create tagtype "asdf"</li><li>Replace tagtype "[Basic] Text/HTML"</li><li>Create page "blahblah"</li></ul>', true) );

$wizard->lastStep();
} else if( $stepNr == 7 ) {
//               
 node_class("labelcomponent");
$form->addComponent( 'lbl', new LabelComponent(null, i18n( 'The uploaded exportfile is part of an already existing import.' )) );
$form->addComponent( 'lbl2', new LabelComponent(null, i18n( 'Press {0} to update the existing import to the uploaded file.', 0, $this->getDoneLabel()) ) );

$wizard->lastStep();
}
$this->fillStep($wizard, $stepNr, $form);
}

function getDoneLabel() {
return i18n( 'Run importtest in background' );
}

function done( &$wizard ) {
global $USER_ID;

$step1 =& $wizard->getStep(1);
$step4 =& $wizard->getStep(4);
$chooser = $step1->resolveComponent( 'chooser' );
$dlurllist = $chooser->getComponent( 'dlurlList' );
$downloadurlComp = $dlurllist->getComponent( 'downloadurl' );
$newbundle = &$downloadurlComp->getFieldValue('newbundle');
$build = &$downloadurlComp->getFieldValue('build');
$isupdate = $downloadurlComp->getFieldValue('isupdate');

//                                                        
 $group_id = -1;
$overridegroup =& $step1->resolveComponent("overridegroup");
if ($overridegroup->isChecked() ) {
$importgroup = $step1->resolveComponent("importgroup");
$groupObject = $importgroup->getResultObject();
if ($groupObject) {
$group_id = $groupObject->getID();
}
}

if( $isupdate ) {
//                        
 $savebuild = new BundleBuild();
//                      
 $bundle_id = $downloadurlComp->getFieldValue('newbundle_id');
$mybuild = &$newbundle->_builds[0];
$mybuild->copyFieldValues( $savebuild );
$savebuild->setFieldValue('bundle_id', $bundle_id);
$savebuild->setFieldValue('group_id', $newbundle->getFieldValue('importgroup_id'));
$savebuild->save();
} else {

//                                
 $savebundle = new Bundle();
$newbundle->copyFieldValues($savebundle);

$savebundle->setFieldValue( 'isimported', 1 );
$savebundle->setFieldValue('importgroup_id', $group_id);
$savebundle->save();

//                        
 $savebuild = new BundleBuild();
$build->copyFieldValues($savebuild);
$savebuild->setFieldValue('bundle_id', $savebundle->getID());
$savebuild->setFieldValue('group_id', $newbundle->getFieldValue('importgroup_id'));
$savebuild->save();

}


//                                               
 $savebuild->createNewImport(true, $group_id);

//                   
 //                                         
 global $REDO, $type;
$REDO = 1010;
$type = 'import';
}

function cancel(&$form) {
global $REDO, $type;
$REDO = 1010;
$type = 'import';
}
}


function selectVersion(&$form) {
$list =& $form->resolveComponent("selectversion");
$value = $list->getSingleSelection();
if ($value == "other") {
showVersions($form, false);
} else {
showVersions($form, true);
}
}

function switchGroupOverride(&$form) {
$overridegroup =& $form->resolveComponent("overridegroup");
$importgroup =& $form->resolveComponent("importgroup");

$importgroup->setVisible($overridegroup->isChecked());
$importgroup->setOptional(!$overridegroup->isChecked());	
}

function buildVersionList() {
$versionList = new RadioListComponent(i18n("Select Version"));
$versionList->setOptional(true);
return $versionList;
}

function showVersions (&$form, $show) {
$list =& $form->resolveComponent("versions");
$list->setHidden($show);
$list->setOptional($show);
}

$form = new HtmlFormWizard("installwizard");
if ($form->isNew()) {
$installBuilder = new InstallBuilder();
$form->setBuilder($installBuilder);
$form->setHeader(i18n("Install New Bundle"));
}

load_menu(1012, T_BUNDLE_IMPORT_ELEMENT, '',  "<span class=\"addInfo\">" . i18n('Import') . "</span>", 0, array( 'isimport' => 1 ));
?>
